## Do not apply any unauthorized patches to this package!
## - vdanen 05/18/01
##

# Version of ssh-askpass
%define aversion 1.2.2

%define name	openssh
%define version	2.9.9p2
%define release 2.1mdk

Summary:	OpenSSH free Secure Shell (SSH) implementation
Name:		%{name}
Version:	%{version}
Release:	%{release}
URL:		http://www.openssh.com/
Source: 	ftp://ftp.openbsd.org/pub/OpenBSD/OpenSSH/portable/openssh-%{version}.tar.gz
Source1:	http://www.ntrnet.net/~jmknoble/software/x11-ssh-askpass/x11-ssh-askpass-%{aversion}.tar.bz2
Source2: 	ftp://ftp.openbsd.org/pub/OpenBSD/OpenSSH/portable/openssh-%{version}.tar.gz.sig
# ssh-copy-id taken from debian, with "usage" added
Source3:	ssh-copy-id.bz2 
Source4: 	gnome-ssh-askpass.sh
Source5: 	gnome-ssh-askpass.csh
Source6:	ssh-client.sh
Patch0:		openssh-%{version}-initd.patch.bz2
Patch1:		openssh-%{version}-mandrake.patch.bz2
Patch2:		openssh-2.9p2-trans_inter.patch.bz2
# authorized by Damien Miller <djm@openbsd.com>
Patch3:		openssh-2.9p2-check-only-ssl-version.patch.bz2
Patch4:		openssh-2.9p2-fix-Imakefile.patch.bz2
License:	BSD
Group:		Networking/Remote access
BuildRoot:	%{_tmppath}/%{name}-%{version}-buildroot
Obsoletes:	ssh
PreReq:		openssl >= 0.9.5a
BuildRequires:	perl openssl-devel tcp_wrappers-devel pam-devel gnome-libs-devel db1-devel zlib-devel

%package clients
Summary:	OpenSSH Secure Shell protocol clients
Requires:	%{name} = %{version}-%{release}
Group:		Networking/Remote access
Obsoletes:	ssh-clients sftp
Provides:	sftp

%package server
Summary:	OpenSSH Secure Shell protocol server (sshd)
PreReq:		%{name} = %{version}-%{release} chkconfig >= 0.9 pam >= 0.74
Group:		System/Servers
Obsoletes:	ssh-server

%package askpass
Summary:	OpenSSH X11 passphrase dialog
Group:		Networking/Remote access
Requires:	%{name} = %{version}-%{release}
Obsoletes:	ssh-extras
Obsoletes:	ssh-askpass
PreReq:		/usr/sbin/update-alternatives

%package askpass-gnome
Summary:	OpenSSH GNOME passphrase dialog
Group:		Networking/Remote access
Requires:	%{name} = %{version}-%{release}
Obsoletes:	ssh-extras
PreReq:		/usr/sbin/update-alternatives
Provides:	%{name}-askpass

%description
Ssh (Secure Shell) a program for logging into a remote machine and for
executing commands in a remote machine.  It is intended to replace
rlogin and rsh, and provide secure encrypted communications between
two untrusted hosts over an insecure network.  X11 connections and
arbitrary TCP/IP ports can also be forwarded over the secure channel.

OpenSSH is OpenBSD's rework of the last free version of SSH, bringing it
up to date in terms of security and features, as well as removing all 
patented algorithms to separate libraries (OpenSSL).

This package includes the core files necessary for both the OpenSSH
client and server.  To make this package useful, you should also
install openssh-clients, openssh-server, or both.

%description clients
Ssh (Secure Shell) a program for logging into a remote machine and for
executing commands in a remote machine.  It is intended to replace
rlogin and rsh, and provide secure encrypted communications between
two untrusted hosts over an insecure network.  X11 connections and
arbitrary TCP/IP ports can also be forwarded over the secure channel.

OpenSSH is OpenBSD's rework of the last free version of SSH, bringing it
up to date in terms of security and features, as well as removing all 
patented algorithms to separate libraries (OpenSSL).

This package includes the clients necessary to make encrypted connections
to SSH servers.

%description server
Ssh (Secure Shell) a program for logging into a remote machine and for
executing commands in a remote machine.  It is intended to replace
rlogin and rsh, and provide secure encrypted communications between
two untrusted hosts over an insecure network.  X11 connections and
arbitrary TCP/IP ports can also be forwarded over the secure channel.

OpenSSH is OpenBSD's rework of the last free version of SSH, bringing it
up to date in terms of security and features, as well as removing all 
patented algorithms to separate libraries (OpenSSL).

This package contains the secure shell daemon. The sshd is the server 
part of the secure shell protocol and allows ssh clients to connect to 
your host.

%description askpass
Ssh (Secure Shell) a program for logging into a remote machine and for
executing commands in a remote machine.  It is intended to replace
rlogin and rsh, and provide secure encrypted communications between
two untrusted hosts over an insecure network.  X11 connections and
arbitrary TCP/IP ports can also be forwarded over the secure channel.

OpenSSH is OpenBSD's rework of the last free version of SSH, bringing it
up to date in terms of security and features, as well as removing all 
patented algorithms to separate libraries (OpenSSL).

This package contains Jim Knoble's <jmknoble@pobox.com> X11 passphrase 
dialog.

%description askpass-gnome
Ssh (Secure Shell) a program for logging into a remote machine and for
executing commands in a remote machine.  It is intended to replace
rlogin and rsh, and provide secure encrypted communications between
two untrusted hosts over an insecure network.  X11 connections and
arbitrary TCP/IP ports can also be forwarded over the secure channel.

OpenSSH is OpenBSD's rework of the last free version of SSH, bringing it
up to date in terms of security and features, as well as removing all 
patented algorithms to separate libraries (OpenSSL).

This package contains the GNOME passphrase dialog.

%prep
%setup -q -a 1
# only apply patches to config/init
%patch0 -p1 -b .init
%patch1 -p1 -b .mdkconf
#%patch2 -p1 -b .trans_inter

# authorized by Damien Miller <djm@openbsd.com>
%patch3 -p1 -b .ssl_ver

%patch4 -p1 -b .imake

%build

%serverbuild

CFLAGS="$RPM_OPT_FLAGS" ./configure --prefix=%{_prefix} \
  --sysconfdir=%{_sysconfdir}/ssh --with-tcp-wrappers \
  --with-rsh=%{_bindir}/rsh --with-pam --libexecdir=%{_libdir}/ssh \
  --mandir=%{_mandir} --with-default-path=/usr/local/bin:/bin:/usr/bin:/usr/X11R6/bin \
  --with-xauth=/usr/X11R6/bin/xauth
make

cd x11-ssh-askpass-%{aversion}
CFLAGS="$RPM_OPT_FLAGS" ./configure --prefix=%{_prefix} \
  --mandir=%{_mandir} --libexecdir=%{_libdir}/ssh \
  --with-app-defaults-dir=%{_libdir}/X11/app-defaults
xmkmf -a
make
cd ..

cd contrib
gcc -O -g `gnome-config --cflags gnome gnomeui` `gtk-config --cflags` `glib-config --cflags`  \
        gnome-ssh-askpass.c -o gnome-ssh-askpass \
        `gnome-config --libs gnome gnomeui`
cd ..

%install
rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT/

install -d $RPM_BUILD_ROOT%{_sysconfdir}/ssh
install -d $RPM_BUILD_ROOT%{_sysconfdir}/pam.d/
install -d $RPM_BUILD_ROOT%{_initrddir}
install -m644 contrib/redhat/sshd.pam $RPM_BUILD_ROOT%{_sysconfdir}/pam.d/sshd
install -m755 contrib/redhat/sshd.init $RPM_BUILD_ROOT%{_initrddir}/sshd

if [[ -f sshd_config.out ]]; then 
	install -m600 sshd_config.out $RPM_BUILD_ROOT%{_sysconfdir}/ssh/sshd_config
else 
	install -m600 sshd_config $RPM_BUILD_ROOT%{_sysconfdir}/ssh/sshd_config
fi

if [[ -f ssh_config.out ]]; then
    install -m644 ssh_config.out $RPM_BUILD_ROOT%{_sysconfdir}/ssh/ssh_config
else
    install -m644 ssh_config $RPM_BUILD_ROOT%{_sysconfdir}/ssh/ssh_config
fi
echo "    StrictHostKeyChecking no" >> $RPM_BUILD_ROOT%{_sysconfdir}/ssh/ssh_config

mkdir -p $RPM_BUILD_ROOT%{_libdir}/ssh
cd x11-ssh-askpass-%{aversion}
make DESTDIR=$RPM_BUILD_ROOT install
make DESTDIR=$RPM_BUILD_ROOT install.man
cd ..

(cd $RPM_BUILD_ROOT%{_bindir}; ln -s ../../%{_libdir}/ssh/ssh-askpass)

install -m 755 contrib/gnome-ssh-askpass $RPM_BUILD_ROOT%{_libdir}/ssh/gnome-ssh-askpass
install -d $RPM_BUILD_ROOT%{_sysconfdir}/profile.d/
install -m 755 %{SOURCE4} %{SOURCE5} %{SOURCE6} $RPM_BUILD_ROOT%{_sysconfdir}/profile.d/

bzcat %{SOURCE3} > $RPM_BUILD_ROOT/%{_bindir}/ssh-copy-id
chmod a+x $RPM_BUILD_ROOT/%{_bindir}/ssh-copy-id
install -m 644 contrib/ssh-copy-id.1 $RPM_BUILD_ROOT/%{_mandir}/man1/

# fix x11-ssh-askpass manpage
(cd $RPM_BUILD_ROOT%{_mandir}/man1; mv x11-ssh-askpass.1x x11-ssh-askpass.1)

%clean
rm -rf $RPM_BUILD_ROOT

%post server
%_post_service sshd

%preun server
%_preun_service sshd

%post askpass
update-alternatives --install %{_libdir}/ssh/ssh-askpass ssh-askpass %{_libdir}/ssh/x11-ssh-askpass 10

%postun askpass
[ $1 = 0 ] || exit 0
update-alternatives --remove ssh-askpass %{_libdir}/ssh/x11-ssh-askpass

%post askpass-gnome
update-alternatives --install %{_libdir}/ssh/ssh-askpass ssh-askpass %{_libdir}/ssh/gnome-ssh-askpass 20

%postun askpass-gnome
[ $1 = 0 ] || exit 0
update-alternatives --remove ssh-askpass %{_libdir}/ssh/gnome-ssh-askpass

%files
%defattr(-,root,root)
%doc ChangeLog OVERVIEW COPYING.Ylonen README* INSTALL 
%doc CREDITS
%{_bindir}/ssh-keygen
%dir %{_sysconfdir}/ssh
%{_bindir}/ssh-keyscan
%{_mandir}/man1/ssh-keygen.1*
%{_mandir}/man1/ssh-keyscan.1*

%files clients
%defattr(-,root,root)
%{_bindir}/ssh
%{_bindir}/scp
%{_bindir}/ssh-agent
%{_bindir}/ssh-add
%{_bindir}/ssh-copy-id
%{_bindir}/slogin
%{_bindir}/sftp
%{_mandir}/man1/ssh-copy-id.1*
%{_mandir}/man1/slogin.1*
%{_mandir}/man1/ssh.1*
%{_mandir}/man1/scp.1*
%{_mandir}/man1/ssh-agent.1*
%{_mandir}/man1/ssh-add.1*
%{_mandir}/man1/sftp.1*
%config(noreplace) %{_sysconfdir}/ssh/ssh_config
%attr(0755,root,root) %config(noreplace) %{_sysconfdir}/profile.d/ssh-client.sh
%{_bindir}/ssh-askpass

%files server
%defattr(-,root,root)
%{_sbindir}/sshd
%{_libdir}/ssh/sftp-server
%{_mandir}/man8/sshd.8*
%{_mandir}/man8/sftp-server.8*
%attr(0600,root,root) %config(noreplace) %{_sysconfdir}/ssh/sshd_config
%attr(0600,root,root) %config(noreplace) %{_sysconfdir}/pam.d/sshd
%config(noreplace) %{_sysconfdir}/ssh/moduli
%config(noreplace) %{_initrddir}/sshd

%files askpass
%defattr(-,root,root)
%doc x11-ssh-askpass-%{aversion}/README
%doc x11-ssh-askpass-%{aversion}/ChangeLog
%doc x11-ssh-askpass-%{aversion}/SshAskpass*.ad
%{_libdir}/ssh/x11-ssh-askpass
%{_libdir}/X11/app-defaults/SshAskpass
%{_mandir}/man1/x11-ssh-askpass.1*

%files askpass-gnome
%defattr(-,root,root)
%{_libdir}/ssh/gnome-ssh-askpass
%attr(0755,root,root) %config(noreplace)%{_sysconfdir}/profile.d/gnome-ssh-askpass.*

%changelog
* Thu Oct  4 2001 Vincent Danen <vdanen@mandrakesoft.com> 2.9.9p2-2.1mdk
- update for 8.1 (revert default to Protocol 1,2)

* Tue Oct  2 2001 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.9.9p2-2mdk
- Fix xauth path for X11 forwarding.

* Mon Oct  1 2001 Vincent Danen <vdanen@mandrakesoft.com> 2.9.9p2-1mdk
- 2.9.9p2 (security fix)
- regenerate patch 0 (initscript)
- regenerate patch 1 (configs)
- default to using Protocol 2,1 not Protocol 1,2
- /etc/ssh/primes is now called /etc/ssh/moduli

* Sat Sep 01 2001 Florin <florin@mandrakesoft.com> 2.9p2-4mdk
- fix the path in the profile.d files

* Fri Aug 31 2001 Florin <florin@mandrakesoft.com> 2.9p2-3mdk
- fix the reload in the initscript
- add the /etc/profile.d/gnome-ssh-askpass.* files

* Thu Jun 21 2001 Florin <florin@mandrakesoft.com> 2.9p2-2mdk
- move the sources back to the original gz state

* Wed Jun 20 2001 Florin <florin@mandrakesoft.com> 2.9p2-1mdk
- 2.9p2
- bzip2 the sources and the .sig file
- use %{version} for the patches names
- update the patches

* Mon May 21 2001 Frederic Lepied <flepied@mandrakesoft.com> 2.9p1-4mdk
- enable patch 3
- added zlib-devel to BuildRequires (Stephane Lentz).

* Fri May 18 2001 Vincent Danen <vdanen@mandrakesoft.com> 2.9p1-3mdk
- remove transmit_interlude patch, ssl_version patch
- update x11-ssh-askpass to 1.2.2

* Mon May  7 2001 Frederic Lepied <flepied@mandrakesoft.com> 2.9p1-2mdk
- only check version of openssl lib at runtime (and not patchlevel).

* Wed May  2 2001 Frederic Lepied <flepied@mandrakesoft.com> 2.9p1-1mdk
- 2.9p1

* Fri Apr 13 2001 Frederic Lepied <flepied@mandrakesoft.com> 2.5.2p2-3mdk
- put ssh-keyscan in main package
- put scp in client package

* Wed Mar 28 2001 Frederic Lepied <flepied@mandrakesoft.com> 2.5.2p2-2mdk
- use new macros for %%preun et %%post of openssh-server

* Wed Mar 21 2001 Vincent Danen <vdanen@mandrakesoft.com> 2.5.2p2-1mdk
- 2.5.2p2
- more macros
- removed -fomit-frame-pointer from compile flags

* Fri Mar 16 2001 Frederic Lepied <flepied@mandrakesoft.com> 2.5.1p2-7mdk
- removed dependency on openssh-askpass to be able to install without X.

* Fri Mar 16 2001 Frederic Lepied <flepied@mandrakesoft.com> 2.5.1p2-6mdk
- added missing /etc/ssh/primes

* Fri Mar 16 2001 Frederic Lepied <flepied@mandrakesoft.com> 2.5.1p2-5mdk
- corrected trans_inter patch to avoid zero length malloc.

* Tue Mar  6 2001 Frederic Lepied <flepied@mandrakesoft.com> 2.5.1p2-4mdk
- X11 forwarding by default.
- TransmitInterlude patch is back.

* Mon Mar  5 2001 Frederic Lepied <flepied@mandrakesoft.com> 2.5.1p2-3mdk
- remove --with-ipv4-default from configure flag to work fine with ipv6.

* Mon Mar  5 2001 Frederic Lepied <flepied@mandrakesoft.com> 2.5.1p2-2mdk
- pam is back.

* Sat Mar  3 2001 Frederic Lepied <flepied@mandrakesoft.com> 2.5.1p2-1mdk
- Obsoletes/Provides sftp
- 2.5.1p2

* Tue Feb 27 2001 Frederic Lepied <flepied@mandrakesoft.com> 2.5.1p1-1mdk
- correct init.d script to stop only the listening daemon.
- 2.5.1p1: added sftp client and ssh-keyscan.

* Tue Jan 16 2001 Frederic Lepied <flepied@mandrakesoft.com> 2.3.0p1-8mdk
- applied patch for TransmitInterlude adapted by Troels Walsted Hansen.

* Fri Nov 10 2000 Frederic Lepied <flepied@mandrakesoft.com> 2.3.0p1-7mdk
- 2.3.0p1

* Tue Oct 17 2000 Frederic Lepied <flepied@mandrakesoft.com> 2.2.0p1-7mdk
- ssh suid.

* Thu Oct  5 2000 Frederic Lepied <flepied@mandrakesoft.com> 2.2.0p1-6mdk
- don't try Protocol 2 first (chmou sucks).
- ssh not suid.

* Tue Sep 26 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.0p1-5mdk
- Pamstackizification.
- X11Forwarding = yes by defaut.

* Fri Sep 15 2000 Frederic Lepied <flepied@mandrakesoft.com> 2.2.0p1-4mdk
- fixed the init script to restart even if forked daemon are still present.

* Tue Sep 12 2000 Frederic Lepied <flepied@mandrakesoft.com> 2.2.0p1-3mdk
- put priority to 20 for gnome alternative of ssh-askpass.

* Mon Sep 11 2000 Frederic Lepied <flepied@mandrakesoft.com> 2.2.0p1-2mdk
- x11-ssh-askpass version 1.0.1
- new package askpass-gnome (use update-alternatives).

* Thu Sep  7 2000 Frederic Lepied <flepied@mandrakesoft.com> 2.2.0p1-1mdk
- 2.2.0p1
- added copy-id man page
- make a symlink in libdir to ssh-askpass to allow ssh-add to find it.
- added reload and condrestart to init script.

* Tue Aug  8 2000 Pixel <pixel@mandrakesoft.com> 2.1.1p3-3mdk
- remove the BuildRequires gnome-libs-devel

* Thu Aug  3 2000 Pixel <pixel@mandrakesoft.com> 2.1.1p3-2mdk
- cleanup, macrozaition
- add script ssh-copy-id from debian's ssh (i just added a usage)
- StrictHostKeyChecking set to "no" in /etc/ssh/ssh_config (it was "ask"),
  so you won't get the following unless the identification changed
  "The authenticity of host 'linux-mandrake.com' can't be established.
   RSA key fingerprint is 9b:f4:10:21:d6:ff:b2:46:d6:86:b1:42:70:4e:5d:e3.
   Are you sure you want to continue connecting (yes/no)? "

* Thu Jul 13 2000 Frederic Lepied <flepied@mandrakesoft.com> 2.1.1p3-1mdk
- 2.1.1p3

* Mon Jul  3 2000 Frederic Lepied <flepied@mandrakesoft.com> 2.1.1p2-1mdk
- 2.1.1p2

* Wed Jun 14 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.1.1p1-2mdk
- Move all /usr/lib/ files to /usr/bin/.

* Tue Jun 13 2000 Frederic Lepied <flepied@mandrakesoft.com> 2.1.1p1-1mdk
- move /usr/libexec => /usr/lib
- 2.1.1p1

* Thu Jun  8 2000 Frederic Lepied <flepied@mandrakesoft.com> 2.1.0p3-2mdk
- removed unneeded BuildPreReq on gnome-libs-devel.

* Thu Jun  8 2000 Frederic Lepied <flepied@mandrakesoft.com> 2.1.0p3-1mdk
- 2.1.0p3

* Fri May 26 2000 Frederic Lepied <flepied@mandrakesoft.com> 2.1.0p2-1mdk
- 2.1.0p2

* Mon May 08 2000 Jean-Michel Dault <jmdault@mandrakesoft.com> 1.2.2-3mdk
- add Prereq openssl so the post script works.

* Tue Apr 25 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 1.2.2-2mdk
- Upgrade groups.
- Clean-up specs.

* Fri Feb  4 2000 Yoann Vandoorselaere <yoann@mandrakesoft.com>
- openssh 1.2.2 release
- if it exist, install the .out version of ssh[d]_config.

* Mon Jan  3 2000 Jean-Michel Dault <jmdault@netrevolution.com>
- final cleanup for Mandrake 7

* Mon Jan  3 2000 Jean-Michel Dault <jmdault@netrevolution.com>
- updated to 1.2.1pre24
- linked with openssl instead of ssleay

* Mon Jan  3 2000 Yoann Vandoorselaere <yoann@mandrakesoft.com>
- Fix a problem with sshd not using the good path.
- Enable tcp wrapper support.

* Mon Dec 13 1999 Yoann Vandoorselaere <yoann@mandrakesoft.com>
- openssh-1.2pre17 released.

* Thu Dec  2 1999 Yoann Vandoorselaere <yoann@mandrakesoft.com>

- First Mandrake release.
